<?php
/**
 * Internationalization
 *
 * The JigoShop countries class stores country/state data.
 *
 * DISCLAIMER
 *
 * Do not edit or add directly to this file if you wish to upgrade Jigoshop to newer
 * versions in the future. If you wish to customise Jigoshop core for your needs,
 * please use our GitHub repository to publish essential changes for consideration.
 *
 * @package		Jigoshop
 * @category	Internationalization
 * @author		Jigowatt
 * @copyright	Copyright (c) 2011-2012 Jigowatt Ltd.
 * @license		http://jigoshop.com/license/commercial-edition
 */
class jigoshop_countries {

	public static $countries = array(
		'AD'	=>	'Andorra',
		'AE'	=>	'United Arab Emirates',
		'AF'	=>	'Afghanistan',
		'AG'	=>	'Antigua and Barbuda',
		'AI'	=>	'Anguilla',
		'AL'	=>	'Albania',
		'AM'	=>	'Armenia',
		'AN'	=>	'Netherlands Antilles',
		'AO'	=>	'Angola',
		'AQ'	=>	'Antarctica',
		'AR'	=>	'Argentina',
		'AS'	=>	'American Samoa',
		'AT'	=>	'Austria',
		'AU'	=>	'Australia',
		'AW'	=>	'Aruba',
		'AX'	=>	'Aland Islands',
		'AZ'	=>	'Azerbaijan',
		'BA'	=>	'Bosnia and Herzegovina',
		'BB'	=>	'Barbados',
		'BD'	=>	'Bangladesh',
		'BE'	=>	'Belgium',
		'BF'	=>	'Burkina Faso',
		'BG'	=>	'Bulgaria',
		'BH'	=>	'Bahrain',
		'BI'	=>	'Burundi',
		'BJ'	=>	'Benin',
		'BL'	=>	'Saint Barthélemy',
		'BM'	=>	'Bermuda',
		'BN'	=>	'Brunei',
		'BO'	=>	'Bolivia',
		'BR'	=>	'Brazil',
		'BS'	=>	'Bahamas',
		'BT'	=>	'Bhutan',
		'BW'	=>	'Botswana',
		'BY'	=>	'Belarus',
		'BZ'	=>	'Belize',
		'CA'	=>	'Canada',
		'CC'	=>	'Cocos (Keeling) Islands',
		'CD'	=>	'Congo (Kinshasa)',
		'CF'	=>	'Central African Republic',
		'CG'	=>	'Congo (Brazzaville)',
		'CH'	=>	'Switzerland',
		'CI'	=>	'Ivory Coast',
		'CK'	=>	'Cook Islands',
		'CL'	=>	'Chile',
		'CM'	=>	'Cameroon',
		'CN'	=>	'China',
		'CO'	=>	'Colombia',
		'CR'	=>	'Costa Rica',
		'CU'	=>	'Cuba',
		'CV'	=>	'Cape Verde',
		'CX'	=>	'Christmas Island',
		'CY'	=>	'Cyprus',
		'CZ'	=>	'Czech Republic',
		'DE'	=>	'Germany',
		'DJ'	=>	'Djibouti',
		'DK'	=>	'Denmark',
		'DM'	=>	'Dominica',
		'DO'	=>	'Dominican Republic',
		'DZ'	=>	'Algeria',
		'EC'	=>	'Ecuador',
		'EE'	=>	'Estonia',
		'EG'	=>	'Egypt',
		'EH'	=>	'Western Sahara',
		'ER'	=>	'Eritrea',
		'ES'	=>	'Spain',
		'ET'	=>	'Ethiopia',
		'FI'	=>	'Finland',
		'FJ'	=>	'Fiji',
		'FK'	=>	'Falkland Islands',
		'FM'	=>	'Micronesia',
		'FO'	=>	'Faroe Islands',
		'FR'	=>	'France',
		'GA'	=>	'Gabon',
		'GB'	=>	'United Kingdom',
		'GD'	=>	'Grenada',
		'GE'	=>	'Georgia',
		'GF'	=>	'French Guiana',
		'GG'	=>	'Guernsey',
		'GH'	=>	'Ghana',
		'GI'	=>	'Gibraltar',
		'GL'	=>	'Greenland',
		'GM'	=>	'Gambia',
		'GN'	=>	'Guinea',
		'GP'	=>	'Guadeloupe',
		'GQ'	=>	'Equatorial Guinea',
		'GR'	=>	'Greece',
		'GS'	=>	'South Georgia/Sandwich Islands',
		'GT'	=>	'Guatemala',
		'GU'	=>	'Guam',
		'GW'	=>	'Guinea-Bissau',
		'GY'	=>	'Guyana',
		'HK'	=>	'Hong Kong',
		'HN'	=>	'Honduras',
		'HR'	=>	'Croatia',
		'HT'	=>	'Haiti',
		'HU'	=>	'Hungary',
		'ID'	=>	'Indonesia',
		'IE'	=>	'Ireland',
		'IL'	=>	'Israel',
		'IM'	=>	'Isle of Man',
		'IN'	=>	'India',
		'IO'	=>	'British Indian Ocean Territory',
		'IQ'	=>	'Iraq',
		'IR'	=>	'Iran',
		'IS'	=>	'Iceland',
		'IT'	=>	'Italy',
		'JE'	=>	'Jersey',
		'JM'	=>	'Jamaica',
		'JO'	=>	'Jordan',
		'JP'	=>	'Japan',
		'KE'	=>	'Kenya',
		'KG'	=>	'Kyrgyzstan',
		'KH'	=>	'Cambodia',
		'KI'	=>	'Kiribati',
		'KM'	=>	'Comoros',
		'KN'	=>	'Saint Kitts and Nevis',
		'KP'	=>	'North Korea',
		'KR'	=>	'South Korea',
		'KW'	=>	'Kuwait',
		'KY'	=>	'Cayman Islands',
		'KZ'	=>	'Kazakhstan',
		'LA'	=>	'Laos',
		'LB'	=>	'Lebanon',
		'LC'	=>	'Saint Lucia',
		'LI'	=>	'Liechtenstein',
		'LK'	=>	'Sri Lanka',
		'LR'	=>	'Liberia',
		'LS'	=>	'Lesotho',
		'LT'	=>	'Lithuania',
		'LU'	=>	'Luxembourg',
		'LV'	=>	'Latvia',
		'LY'	=>	'Libya',
		'MA'	=>	'Morocco',
		'MC'	=>	'Monaco',
		'MD'	=>	'Moldova',
		'ME'	=>	'Montenegro',
		'MF'	=>	'Saint Martin (French part)',
		'MG'	=>	'Madagascar',
		'MH'	=>	'Marshall Islands',
		'MK'	=>	'Macedonia',
		'ML'	=>	'Mali',
		'MM'	=>	'Myanmar',
		'MN'	=>	'Mongolia',
		'MO'	=>	'Macao S.A.R., China',
		'MP'	=>	'Northern Mariana Islands',
		'MQ'	=>	'Martinique',
		'MR'	=>	'Mauritania',
		'MS'	=>	'Montserrat',
		'MT'	=>	'Malta',
		'MU'	=>	'Mauritius',
		'MV'	=>	'Maldives',
		'MW'	=>	'Malawi',
		'MX'	=>	'Mexico',
		'MY'	=>	'Malaysia',
		'MZ'	=>	'Mozambique',
		'NA'	=>	'Namibia',
		'NC'	=>	'New Caledonia',
		'NE'	=>	'Niger',
		'NF'	=>	'Norfolk Island',
		'NG'	=>	'Nigeria',
		'NI'	=>	'Nicaragua',
		'NL'	=>	'Netherlands',
		'NO'	=>	'Norway',
		'NP'	=>	'Nepal',
		'NR'	=>	'Nauru',
		'NU'	=>	'Niue',
		'NZ'	=>	'New Zealand',
		'OM'	=>	'Oman',
		'PA'	=>	'Panama',
		'PE'	=>	'Peru',
		'PF'	=>	'French Polynesia',
		'PG'	=>	'Papua New Guinea',
		'PH'	=>	'Philippines',
		'PK'	=>	'Pakistan',
		'PL'	=>	'Poland',
		'PM'	=>	'Saint Pierre and Miquelon',
		'PN'	=>	'Pitcairn',
		'PR'	=>	'Puerto Rico',
		'PS'	=>	'Palestinian Territory',
		'PT'	=>	'Portugal',
		'PW'	=>	'Palau',
		'PY'	=>	'Paraguay',
		'QA'	=>	'Qatar',
		'RE'	=>	'Reunion',
		'RO'	=>	'Romania',
		'RS'	=>	'Serbia',
		'RU'	=>	'Russia',
		'RW'	=>	'Rwanda',
		'SA'	=>	'Saudi Arabia',
		'SB'	=>	'Solomon Islands',
		'SC'	=>	'Seychelles',
		'SD'	=>	'Sudan',
		'SE'	=>	'Sweden',
		'SG'	=>	'Singapore',
		'SH'	=>	'Saint Helena',
		'SI'	=>	'Slovenia',
		'SJ'	=>	'Svalbard and Jan Mayen',
		'SK'	=>	'Slovakia',
		'SL'	=>	'Sierra Leone',
		'SM'	=>	'San Marino',
		'SN'	=>	'Senegal',
		'SO'	=>	'Somalia',
		'SR'	=>	'Suriname',
		'ST'	=>	'Sao Tome and Principe',
		'SV'	=>	'El Salvador',
		'SY'	=>	'Syria',
		'SZ'	=>	'Swaziland',
		'TC'	=>	'Turks and Caicos Islands',
		'TD'	=>	'Chad',
		'TF'	=>	'French Southern Territories',
		'TG'	=>	'Togo',
		'TH'	=>	'Thailand',
		'TJ'	=>	'Tajikistan',
		'TK'	=>	'Tokelau',
		'TL'	=>	'Timor-Leste',
		'TM'	=>	'Turkmenistan',
		'TN'	=>	'Tunisia',
		'TO'	=>	'Tonga',
		'TR'	=>	'Turkey',
		'TT'	=>	'Trinidad and Tobago',
		'TV'	=>	'Tuvalu',
		'TW'	=>	'Taiwan',
		'TZ'	=>	'Tanzania',
		'UA'	=>	'Ukraine',
		'UG'	=>	'Uganda',
		'UM'	=>	'US Minor Outlying Islands',
		'US'	=>	'United States',
		'USAF'	=>	'US Armed Forces',
		'UY'	=>	'Uruguay',
		'UZ'	=>	'Uzbekistan',
		'VA'	=>	'Vatican',
		'VC'	=>	'Saint Vincent and the Grenadines',
		'VE'	=>	'Venezuela',
		'VG'	=>	'British Virgin Islands',
		'VI'	=>	'U.S. Virgin Islands',
		'VN'	=>	'Viet nam',
		'VU'	=>	'Vanuatu',
		'WF'	=>	'Wallis and Futuna',
		'WS'	=>	'Samoa',
		'YE'	=>	'Yemen',
		'YT'	=>	'Mayotte',
		'ZA'	=>	'South Africa',
		'ZM'	=>	'Zambia',
		'ZW'	=>	'Zimbabwe'
		);

	public static $states = array(

		// Albania: Prefectures ("qarks")
		'AL'	=>	array(
			'BER'	=>	'Berat',
			'DIB'	=>	'Dib&euml;r',
			'DUR'	=>	'Durr&euml;s',
			'ELB'	=>	'Elbasan',
			'FIE'	=>	'Fier',
			'GJI'	=>	'Gjirokast&euml;r',
			'KOR'	=>	'Kor&ccedil;&euml;',
			'KUK'	=>	'Kuk&euml;s',
			'LEZ'	=>	'Lezh&euml;',
			'SHK'	=>	'Shkod&euml;r',
			'TIR'	=>	'Tiran&euml;',
			'VLO'	=>	'Vlor&euml;'
		),
		'AU'	=>	array(
			'ACT'	=>	'Australian Capital Territory',
			'NSW'	=>	'New South Wales',
			'NT'	=>	'Northern Territory',
			'QLD'	=>	'Queensland',
			'SA'	=>	'South Australia',
			'TAS'	=>	'Tasmania',
			'VIC'	=>	'Victoria',
			'WA'	=>	'Western Australia'
		),
		'BR'	=>	array(
			'AC'	=>	'Acre',
			'AL'	=>	'Alagoas',
			'AM'	=>	'Amazonas',
			'AP'	=>	'Amap&aacute;',
			'BA'	=>	'Bahia',
			'CE'	=>	'Cear&aacute;',
			'DF'	=>	'Distrito federal',
			'ES'	=>	'Esp&#237;rito santo',
			'GO'	=>	'Goi&aacute;s',
			'MA'	=>	'Maranh&atilde;o',
			'MG'	=>	'Minas gerais',
			'MS'	=>	'Mato grosso do sul',
			'MT'	=>	'Mato grosso',
			'PA'	=>	'Par&aacute;',
			'PB'	=>	'Paraiba',
			'PE'	=>	'Pernambuco',
			'PI'	=>	'Piau&iacute;',
			'PR'	=>	'Paran&aacute;',
			'RJ'	=>	'Rio de janeiro',
			'RN'	=>	'Rio grande do norte',
			'RO'	=>	'Rond&ocirc;nia',
			'RR'	=>	'Roraima',
			'RS'	=>	'Rio grande do sul',
			'SC'	=>	'Santa catarina',
			'SE'	=>	'Sergipe',
			'SP'	=>	'S&atilde;o paulo',
			'TO'	=>	'Tocantins'
		),
		'CA'	=>	array(
			'AB'	=>	'Alberta',
			'BC'	=>	'British Columbia',
			'MB'	=>	'Manitoba',
			'NB'	=>	'New Brunswick',
			'NL'	=>	'Newfoundland',
			'NS'	=>	'Nova Scotia',
			'NT'	=>	'Northwest Territories',
			'NU'	=>	'Nunavut',
			'ON'	=>	'Ontario',
			'PE'	=>	'Prince Edward Island',
			'QC'	=>	'Quebec',
			'SK'	=>	'Saskatchewan',
			'YT'	=>	'Yukon Territory'
		),

		// Switzerland: Cantons
		'CH'	=>	array(
			'AG'	=>	'Aargau',
			'AI'	=>	'Appenzell Innerrhoden',
			'AR'	=>	'Appenzell Ausserrhoden',
			'BE'	=>	'Bern',
			'BL'	=>	'Basel-Landschaft',
			'BS'	=>	'Basel-Stadt',
			'FR'	=>	'Freiburg',
			'GE'	=>	'Genf',
			'GL'	=>	'Glarus',
			'JU'	=>	'Graub&#252;nden',
			'JU'	=>	'Jura',
			'LU'	=>	'Luzern',
			'NE'	=>	'Neuenburg',
			'NW'	=>	'Nidwalden',
			'OW'	=>	'Obwalden',
			'SG'	=>	'St. Gallen',
			'SH'	=>	'Schaffhausen',
			'SO'	=>	'Solothurn',
			'SZ'	=>	'Schwyz',
			'TG'	=>	'Thurgau',
			'TI'	=>	'Tessin',
			'UR'	=>	'Uri',
			'VD'	=>	'Waadt',
			'VS'	=>	'Wallis',
			'ZG'	=>	'Zug',
			'ZH'	=>	'Z&#252;rich'
		),

		// Spain: Provinces
		'ES'	=>	array(
			'AA'	=>	 '&Aacute;lava' ,
			'AB'	=>	 'Albacete' ,
			'AN'	=>	 'Alicante' ,
			'AM'	=>	 'Almer&iacute;a' ,
			'AS'	=>	 'Asturias' ,
			'AV'	=>	 '&Aacute;vila' ,
			'BD'	=>	 'Badajoz' ,
			'BL'	=>	 'Baleares' ,
			'BR'	=>	 'Barcelona' ,
			'BU'	=>	 'Burgos' ,
			'CC'	=>	 'C&aacute;ceres' ,
			'CD'	=>	 'C&aacute;diz' ,
			'CN'	=>	 'Cantabria' ,
			'CS'	=>	 'Castell&oacute;n' ,
			'CE'	=>	 'Ceuta' ,
			'CR'	=>	 'Ciudad Real' ,
			'CO'	=>	 'C&oacute;rdoba' ,
			'CU'	=>	 'Cuenca' ,
			'GN'	=>	 'Gerona' ,
			'GD'	=>	 'Granada' ,
			'GJ'	=>	 'Guadalajara' ,
			'GP'	=>	 'Guip&uacute;zcoa' ,
			'HL'	=>	 'Huelva' ,
			'HS'	=>	 'Huesca' ,
			'JA'	=>	 'Ja&eacute;n' ,
			'AC'	=>	 'La Coru&ntilde;a' ,
			'LR'	=>	 'La Rioja' ,
			'LP'	=>	 'Las Palmas' ,
			'LN'	=>	 'Le&oacute;n' ,
			'LD'	=>	 'L&eacute;rida' ,
			'LG'	=>	 'Lugo' ,
			'MD'	=>	 'Madrid' ,
			'MG'	=>	 'M&aacute;laga' ,
			'ME'	=>	 'Melilla' ,
			'MR'	=>	 'Murcia' ,
			'NV'	=>	 'Navarra' ,
			'OR'	=>	 'Orense' ,
			'PL'	=>	 'Palencia' ,
			'PV'	=>	 'Pontevedra' ,
			'SL'	=>	 'Salamanca' ,
			'SC'	=>	 'Santa Cruz de Tenerife' ,
			'SG'	=>	 'Segovia' ,
			'SV'	=>	 'Sevilla' ,
			'SR'	=>	 'Soria' ,
			'TG'	=>	 'Tarragona' ,
			'TE'	=>	 'Teruel' ,
			'TD'	=>	 'Toledo' ,
			'VN'	=>	 'Valencia' ,
			'VD'	=>	 'Valladolid' ,
			'VZ'	=>	 'Vizcaya' ,
			'ZM'	=>	 'Zamora' ,
			'ZG'	=>	 'Zaragoza'
		),

		// Czech Republic: Regions
		'CZ'	=>	array(
			'JC'	=>	'Jihocesk&yacute; kraj&nbsp;[South Bohemian Region]',
			'JM'	=>	'Jihomoravsk&yacute; kraj&nbsp;[South Moravian Region]',
			'KA'	=>	'Karlovarsk&yacute; kraj&nbsp;[Karlovy Vary Region]',
			'KR'	=>	'Kr&aacute;lov&eacute;hradeck&yacute; kraj&nbsp;[Hradec Kr&aacute;lov&eacute; Region]',
			'LI'	=>	'Libereck&yacute; kraj&nbsp;[Liberec Region]',
			'MO'	=>	'Moravskoslezsk&yacute; kraj&nbsp;[Moravian-Silesian Region]',
			'OL'	=>	'Olomouck&yacute; kraj&nbsp;[Olomouc Region]',
			'PA'	=>	'Pardubick&yacute; kraj&nbsp;[Pardubice Region]',
			'PL'	=>	'Plzensk&yacute; kraj&nbsp;[Plzen Region]',
			'PR'	=>	'Praha&nbsp;(Hlavni mesto Praha) [Prague]',
			'ST'	=>	'Stredocesk&yacute; kraj&nbsp;[Central Bohemian Region]',
			'US'	=>	'&Uacute;steck&yacute; kraj&nbsp;[&Uacute;st&iacute; Region]',
			'VY'	=>	'Vysocina',
			'ZL'	=>	'Zl&iacute;nsk&yacute; kraj&nbsp;[Zl&iacute;n Region]'
		),

		// Germany: Federal States
		'DE'	=>	array(
			'NDS'	=>	'Niedersachsen',
			'BAW'	=>	'Baden-W&#252;rttemberg',
			'BAY'	=>	'Bayern',
			'BER'	=>	'Berlin',
			'BRG'	=>	'Brandenburg',
			'BRE'	=>	'Bremen',
			'HAM'	=>	'Hamburg',
			'HES'	=>	'Hessen',
			'MEC'	=>	'Mecklenburg-Vorpommern',
			'NRW'	=>	'Nordrhein-Westfalen',
			'RHE'	=>	'Rheinland-Pfalz',
			'SAR'	=>	'Saarland',
			'SAS'	=>	'Sachsen',
			'SAC'	=>	'Sachsen-Anhalt',
			'SCN'	=>	'Schleswig-Holstein',
			'THE'	=>	'Th&#252;ringen'
		),

		// Finland: Regions
		'FI'	=>	array(
			'&Aring;AL'	=>	'&Aring;land',
			'EKA'		=>	'Etel&auml;-Karjala [South Karelia]',
			'EPO'		=>	'Etel&auml;-Pohjanmaa [South Ostrobothnia]',
			'ESA'		=>	'Etel&auml;-Savo',
			'KAI'		=>	'Kainuu',
			'KH&Auml;'	=>	'Kanta-H&auml;me',
			'KPO'		=>	'Keski-Pohjanmaa [Central Ostrobothnia]',
			'KSO'		=>	'Keski-Suomi [Central Finland]',
			'KYM'		=>	'Kymenlaakso (Kymmenedalen)',
			'LAP'		=>	'Lappi [Lapland]',
			'PH&Auml;'	=>	'P&auml;ij&auml;t-H&auml;me',
			'PIR'		=>	'Pirkanmaa',
			'POH'		=>	'Pohjanmaa [Ostrobothnia]',
			'PKA'		=>	'Pohjois-Karjala [North Karelia]',
			'PPO'		=>	'Pohjois-Pohjanmaa [North Ostrobothnia]',
			'PSA'		=>	'Pohjois-Savo',
			'SAT'		=>	'Satakunta',
			'UUS'		=>	'Uusimaa (Nyland)',
			'VSS'		=>	'Varsinais-Suomi (Egentliga Finland)'
		),

		// France: Regions
		'FR'	=>	array(
			'ALS'	=>	'Alsace',
			'AQU'	=>	'Aquitaine',
			'AUV'	=>	'Auvergne',
			'BAS'	=>	'Basse-Normandie [Lower Normandy]',
			'BOU'	=>	'Bourgogne [Burgundy]',
			'BRE'	=>	'Bretagne [Brittany]',
			'CEN'	=>	'Centre',
			'CHA'	=>	'Champagne - Ardenne',
			'COR'	=>	'Corse',
			'FRA'	=>	'Franche-Comt&eacute;',
			'HAU'	=>	'Haute-Normandie [Upper Normandy]',
			'ILE'	=>	'&Icirc;le-de-France',
			'LAN'	=>	'Languedoc - Roussillon',
			'LIM'	=>	'Limousin',
			'LOR'	=>	'Lorraine',
			'MID'	=>	'Midi - Pyr&eacute;n&eacute;es',
			'NOR'	=>	'Nord - Pas-de-Calais',
			'PAY'	=>	'Pays de la Loire',
			'PIC'	=>	'Picardie',
			'POI'	=>	'Poitou - Charentes',
			'PRO'	=>	'Provence - Alpes - C&ocirc;te d\'Azur',
			'RHO'	=>	'Rh&ocirc;ne - Alpes'
		),

		// Greece: Regions
		'GR'	=>	array(
			'AOR'	=>	'&Aacute;gio &Oacute;ros [Mount Athos]',
			'AMT'	=>	'Anatolik&iacute; Makedon&iacute;a &amp; Thrak&iacute; [East Macedonia &amp; Thrace]',
			'ATT'	=>	'Attik&iacute; [Attica]',
			'DEL'	=>	'Dytik&iacute; Ell&aacute;da [Western Greece]',
			'DMD'	=>	'Dytik&iacute; Makedon&iacute;a [West Macedonia]',
			'ION'	=>	'I&oacute;nia Nisi&aacute; [Ionian Islands]',
			'IPI'	=>	'&Iacute;piros [Epirus]',
			'KMD'	=>	'Kedrik&iacute; Makedon&iacute;a [Central Macedonia]',
			'KRI'	=>	'Kr&iacute;ti [Crete]',
			'NAI'	=>	'N&oacute;tio Aiga&iacute;o [South Aegean]',
			'PEL'	=>	'Pelop&oacute;nnisos [Peloponnese]',
			'SEL'	=>	'Stere&aacute; Ell&aacute;da [Central Greece]',
			'THE'	=>	'Thessal&iacute;a [Thessaly]',
			'VAI'	=>	'V&oacute;rio Aiga&iacute;o [Northern Aegean]'
		),

		'HK'	=>	array(
			'HONG KONG'			=>	'Hong Kong Island',
			'KOWLOONG'			=>	'Kowloong',
			'NEW TERRITORIES'	=>	'New Territories'
		),

		// Hungary: Counties
		'HU'	=>	array(
			'BAC'		=>	'B&aacute;cs-Kiskun',
			'BAR'		=>	'Baranya',
			'BEK'		=>	'B&eacute;k&eacute;s',
			'BOR'		=>	'Borsod-Aba&uacute;j-Zempl&eacute;n',
			'BUD'		=>	'Budapest',
			'CSO'		=>	'Csongr&aacute;d',
			'FEJ'		=>	'Fej&eacute;r',
			'GY&Ouml;'	=>	'Gyor-Moson-Sopron',
			'HAJ'		=>	'Hajd&uacute;-Bihar',
			'HEV'		=>	'Heves',
			'JAS'		=>	'J&aacute;sz-Nagykun-Szolnok',
			'KOM'		=>	'Kom&aacute;rom-Esztergom',
			'NOG'		=>	'N&oacute;gr&aacute;d',
			'PES'		=>	'Pest',
			'SOM'		=>	'Somogy',
			'SZA'		=>	'Szabolcs-Szatm&aacute;r-Bereg',
			'TOL'		=>	'Tolna',
			'VAS'		=>	'Vas',
			'VES'		=>	'Veszpr&eacute;m',
			'ZAL'		=>	'Zala'
		),

		// Ireland: Counties
		'IE'	=>	array(
			'G'		=>	'Galway (incl. Galway City)',
			'LM'	=>	'Leitrim',
			'MO'	=>	'Mayo',
			'RN'	=>	'Roscommon',
			'SO'	=>	'Sligo',
			'CW'	=>	'Carlow',
			'D'		=>	'Dublin',
			'DR'	=>	'D&uacute;n Laoghaire-Rathdown',
			'FG'	=>	'Fingal',
			'KE'	=>	'Kildare',
			'KK'	=>	'Kilkenny',
			'LS'	=>	'Laois',
			'LD'	=>	'Longford',
			'LH'	=>	'Louth',
			'MH'	=>	'Meath',
			'OY'	=>	'Offaly',
			'SD'	=>	'South Dublin',
			'WH'	=>	'Westmeath',
			'WX'	=>	'Wexford',
			'WW'	=>	'Wicklow',
			'CE'	=>	'Clare',
			'C'		=>	'Cork (incl. Cork City)',
			'KY'	=>	'Kerry',
			'LK'	=>	'Limerick (incl. Limerick City)',
			'NT'	=>	'North Tipperary',
			'ST'	=>	'South Tipperary',
			'WD'	=>	'Waterford (incl. Waterford City)',
			'CN'	=>	'Cavan',
			'DL'	=>	'Donegal',
			'MIN'	=>	'Monaghan'
		),

		// Netherlands: Provinces
		'NL'	=>	array(
			'D'		=>	'Drenthe',
			'Fl'	=>	'Flevoland',
			'Fr'	=>	'Friesland',
			'Gld'	=>	'Gelderland',
			'Gr'	=>	'Groningen',
			'L'		=>	'Limburg',
			'N-B'	=>	'Noord-Brabant',
			'N-H'	=>	'Noord-Holland',
			'O'		=>	'Overijssel',
			'U'		=>	'Utrecht',
			'Z'		=>	'Zeeland',
			'Z-H'	=>	'Zuid-Holland'
		),

		// Romania: Counties
		'RO'	=>	array(
			'ALB'	=>	'Alba',
			'ARA'	=>	'Arad',
			'ARG'	=>	'Arges',
			'BAC'	=>	'Bacau',
			'BIH'	=>	'Bihor',
			'BIS'	=>	'Bistrita-Nasaud',
			'BOT'	=>	'Botosani',
			'BRA'	=>	'Braila',
			'BRS'	=>	'Brasov',
			'BUC'	=>	'Bucuresti',
			'BUZ'	=>	'Buzau',
			'CAL'	=>	'Calarasi',
			'CAR'	=>	'Caras-Severin',
			'CLU'	=>	'Cluj',
			'CON'	=>	'Constanta',
			'COV'	=>	'Covasna',
			'DAM'	=>	'D&acirc;mbovita',
			'DOL'	=>	'Dolj',
			'GAL'	=>	'Galati',
			'GIU'	=>	'Giurgiu',
			'GOR'	=>	'Gorj',
			'HAR'	=>	'Harghita',
			'HUN'	=>	'Hunedoara',
			'IAL'	=>	'Ialomita',
			'IAS'	=>	'Iasi',
			'ILF'	=>	'Ilfov',
			'MAR'	=>	'Maramures',
			'MEH'	=>	'Mehedinti',
			'MUR'	=>	'Mures',
			'NEA'	=>	'Neamt',
			'OLT'	=>	'Olt',
			'PRA'	=>	'Prahova',
			'SAL'	=>	'Salaj',
			'SAT'	=>	'Satu Mare',
			'SIB'	=>	'Sibiu',
			'SUC'	=>	'Suceava',
			'TEL'	=>	'Teleorman',
			'TIM'	=>	'Timis',
			'TUL'	=>	'Tulcea',
			'VAL'	=>	'V&acirc;lcea',
			'VAS'	=>	'Vaslui',
			'VRA'	=>	'Vrancea'
		),

		// Serbia: Districts
		'SR'	=>	array(
			'BOR'	=>	'Bor',
			'BRA'	=>	'Branicevo',
			'GBE'	=>	'Grad Beograd&nbsp;',
			'JAB'	=>	'Jablanica',
			'KOL'	=>	'Kolubara',
			'MAC'	=>	'Macva',
			'MOR'	=>	'Moravica',
			'NIS'	=>	'Ni&scaron;ava',
			'PCI'	=>	'Pcinja',
			'PIR'	=>	'Pirot',
			'POD'	=>	'Podunavlje&nbsp;[Danube]',
			'POM'	=>	'Pomoravlje',
			'RSN'	=>	'Rasina',
			'RSK'	=>	'Ra&scaron;ka',
			'SUM'	=>	'&Scaron;umadija',
			'TOP'	=>	'Toplica',
			'ZAJ'	=>	'Zajecar',
			'ZLA'	=>	'Zlatibor',
			'JBK'	=>	'Ju&#382;na Backa&nbsp;',
			'JBN'	=>	'Ju&#382;ni Banat&nbsp;',
			'SBK'	=>	'Severna Backa&nbsp;',
			'SBN'	=>	'Severni Banat&nbsp;',
			'SRB'	=>	'Srednji Banat&nbsp;',
			'SRE'	=>	'Srem',
			'ZBK'	=>	'Zapadna Backa&nbsp;[West Backa]'
		),

		// Sweden: Counties ("l&auml;n")
		'SE'	=>	array(
			'BLE'		=>	'Blekinge l&auml;n',
			'DAL'		=>	'Dalarnas l&auml;n',
			'G&Auml;V'	=>	'G&auml;vleborgs l&auml;n',
			'GOT'		=>	'Gotlands l&auml;n',
			'HAL'		=>	'Hallands l&auml;n',
			'J&Auml;M'	=>	'J&auml;mtlands l&auml;n',
			'J&Ouml;N'	=>	'J&ouml;nk&ouml;pings l&auml;n',
			'KAL'		=>	'Kalmar l&auml;n',
			'KRO'		=>	'Kronobergs l&auml;n',
			'NOR'		=>	'Norrbottens l&auml;n',
			'&Ouml;RE'	=>	'&Ouml;rebro l&auml;n',
			'&Ouml;ST'	=>	'&Ouml;sterg&ouml;tlands l&auml;n',
			'SKA'		=>	'Sk&aring;ne l&auml;n',
			'S&Ouml;D'	=>	'S&ouml;dermanlands l&auml;n',
			'STO'		=>	'Stockholms l&auml;n',
			'UPP'		=>	'Uppsala l&auml;n',
			'V&Auml;R'	=>	'V&auml;rmlands l&auml;n',
			'V&Auml;S'	=>	'V&auml;sterbottens l&auml;n',
			'VNL'		=>	'V&auml;sternorrlands l&auml;n',
			'VML'		=>	'V&auml;stmanlands l&auml;n',
			'VG&Ouml;'	=>	'V&auml;stra G&ouml;talands l&auml;n'
		),
		'US'	=>	array(
			'AK'	=>	'Alaska',
			'AL'	=>	'Alabama',
			'AR'	=>	'Arkansas',
			'AZ'	=>	'Arizona',
			'CA'	=>	'California',
			'CO'	=>	'Colorado',
			'CT'	=>	'Connecticut',
			'DC'	=>	'District Of Columbia',
			'DE'	=>	'Delaware',
			'FL'	=>	'Florida',
			'GA'	=>	'Georgia',
			'HI'	=>	'Hawaii',
			'IA'	=>	'Iowa',
			'ID'	=>	'Idaho',
			'IL'	=>	'Illinois',
			'IN'	=>	'Indiana',
			'KS'	=>	'Kansas',
			'KY'	=>	'Kentucky',
			'LA'	=>	'Louisiana',
			'MA'	=>	'Massachusetts',
			'MD'	=>	'Maryland',
			'ME'	=>	'Maine',
			'MI'	=>	'Michigan',
			'MN'	=>	'Minnesota',
			'MO'	=>	'Missouri',
			'MS'	=>	'Mississippi',
			'MT'	=>	'Montana',
			'NC'	=>	'North Carolina',
			'ND'	=>	'North Dakota',
			'NE'	=>	'Nebraska',
			'NH'	=>	'New Hampshire',
			'NJ'	=>	'New Jersey',
			'NM'	=>	'New Mexico',
			'NV'	=>	'Nevada',
			'NY'	=>	'New York',
			'OH'	=>	'Ohio',
			'OK'	=>	'Oklahoma',
			'OR'	=>	'Oregon',
			'PA'	=>	'Pennsylvania',
			'RI'	=>	'Rhode Island',
			'SC'	=>	'South Carolina',
			'SD'	=>	'South Dakota',
			'TN'	=>	'Tennessee',
			'TX'	=>	'Texas',
			'UT'	=>	'Utah',
			'VA'	=>	'Virginia',
			'VT'	=>	'Vermont',
			'WA'	=>	'Washington',
			'WI'	=>	'Wisconsin',
			'WV'	=>	'West Virginia',
			'WY'	=>	'Wyoming'
		),
		'USAF'	=>	array(
			'AA'	=>	'Americas',
			'AE'	=>	'Europe',
			'AP'	=>	'Pacific'
		)
	);

	static function country_has_states($country_code) {

		return isset(self::$states[$country_code]);
	}

	/** get base country */
	static function get_base_country() {
		$default = get_option('jigoshop_default_country');
		if (strstr($default, ':')) :
			$country = current(explode(':', $default));
			$state = end(explode(':', $default));
		else :
			$country = $default;
			$state = '*';
		endif;

		return $country;
	}

	/** get base state */
	static function get_base_state() {
		$default = get_option('jigoshop_default_country');
		if (strstr($default, ':')) :
			$country = current(explode(':', $default));
			$state = end(explode(':', $default));
		else :
			$country = $default;
			$state = '*';
		endif;

		return $state;
	}

	/** get countries we allow only */
	function get_allowed_countries() {

		$countries = self::$countries;

		asort($countries);

		if (get_option('jigoshop_allowed_countries')!=='specific') return $countries;

		$allowed_countries = array();

		$allowed_countries_raw = get_option('jigoshop_specific_allowed_countries');

		foreach ($allowed_countries_raw as $country) :

			$allowed_countries[$country] = $countries[$country];

		endforeach;

		asort($allowed_countries);

		return $allowed_countries;
	}

	/** Gets the correct string for shipping - ether 'to the' or 'to' */
	function shipping_to_prefix() {
		$return = '';
		if (in_array(jigoshop_customer::get_country(), array( 'GB', 'US', 'AE', 'CZ', 'DO', 'NL', 'PH', 'USAF' ))) $return = __('to the', 'jigoshop');
		else $return = __('to', 'jigoshop');
		$return = apply_filters('shipping_to_prefix', $return, jigoshop_customer::get_shipping_country());
		return $return;
	}

	function estimated_for_prefix() {
		$return = '';
		if (in_array(jigoshop_customer::get_country(), array( 'GB', 'US', 'AE', 'CZ', 'DO', 'NL', 'PH', 'USAF' ))) $return = __('the ', 'jigoshop');
		$return = apply_filters('estimated_for_prefix', $return, jigoshop_customer::get_shipping_country());
		return $return;
	}

	/** get states */
	function get_states( $cc ) {
		if (isset( self::$states[$cc] )) return self::$states[$cc];
		else return array();
	}

	/** Outputs the list of countries and states for use in dropdown boxes */
	function country_dropdown_options( $selected_country = '', $selected_state = '*', $escape = false, $show_all = true ) {

		$countries = self::$countries;
		asort($countries);

		if ( $countries ) foreach ( $countries as $key=>$value ) :
			$value = $escape ? esc_js($value) : $value;
			if ( $states =  self::get_states($key) ) :
				echo '<optgroup label="'.$value.'">';

				if ($show_all) :
					echo '<option value="'.esc_attr($key).'"';
					if ($selected_country==$key && $selected_state=='*') echo ' selected="selected"';
					echo '>'.__('All of', 'jigoshop').' ' .$value.'</option>';
				endif;

				foreach ($states as $state_key=>$state_value) :
					echo '<option value="'.$key.':'.$state_key.'"';
					if (($selected_country==$key && $selected_state==$state_key) || (!$show_all && ($selected_state=='*' && $selected_country==$key)))
						echo ' selected="selected"';
					echo '>'.$value.' &mdash; '. ($escape ? esc_js($state_value) : $state_value) .'</option>';
				endforeach;

				echo '</optgroup>';

				// Will only run update_option once
				// If the state is '*' , update the default country to the last state in the selected country
				if (!$show_all && ($selected_state == '*' && $selected_country == $key)) :
					update_option('jigoshop_default_country', $key . ':' . $state_key);
				endif;

			else :
				echo '<option';
				if ($selected_country==$key && $selected_state=='*') echo ' selected="selected"';
				echo ' value="'.esc_attr($key).'">'. __($value, 'jigoshop') .'</option>';
			endif;

		endforeach;

	}

	// Called when a base state is set to '*', #545
	function base_country_notice() {
		echo '
			<div class="error">
				<p>'.__('Your <strong>Base Country / Region</strong> setting has been changed to the last state in the country. Please update accordingly', 'jigoshop').'!</p>
				<p>' . sprintf(__('<a href="%s" target="_TOP">Read why</a> we did this for you.','jigoshop'), "https://github.com/jigoshop/jigoshop/issues/545" ) . '</p>
			</div>
		';
	}

}